using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Kav.Data
{
    public struct MeshSpriteDrawData
    {
        public SpriteMesh MeshSprite { get; }
        public Texture2D Texture { get; }
        public Texture2D Normal { get; }
        public SpriteBillboardConstraint BillboardConstraint { get; }
        public Matrix TransformMatrix { get; }
        public UVData UVOffset { get; }

        public MeshSpriteDrawData(
            SpriteMesh meshSprite,
            Texture2D texture,
            Texture2D normal,
            SpriteBillboardConstraint billboardConstraint,
            Matrix transformMatrix,
            UVData offset
        ) {
            MeshSprite = meshSprite;
            Texture = texture;
            Normal = normal;
            BillboardConstraint = billboardConstraint;
            TransformMatrix = transformMatrix;
            UVOffset = offset;
        }
    }
}
